#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <atari.h>
#include "support.h"
#include "gamedata.h"

// Game vars

char nmax_level, nlevel, nbalas, ncartus, nenergy;
BITMAP *bmp_pres;

// PM vars
unsigned long pm, pmb;
unsigned char px0, px1, y0;
unsigned long py0, py1;

// Auxiliar vars
int ss, ndied, salir, tp, sg, i1, i2, i3, nbal;
long aux, l1, l2, i, ii, iii;

// Same as SIGN BASIC
int sign(int v) {
   if(v>0) {
      return(1);
   } else if(v==0) {
      return(0);
   } else {
      return(-1);
   }
}


// Update x0,y0 with joystick read and print sprite cursor
void joystick(void) {
   int s, f;
   s=peek(0x278); //0xD300
   if(s<12) {
      px0=px0+(sign(8-s)+(px0<47)-(px0>200))*1;
      s=s+(s<8)*4+4;
      poke(53248U,px0);
   }
   if(s<15) {
      f=sign(sign(27-s*2)+(y0<16)-(y0>83));
      if(f==-1) {
      	 --y0; mover(pmb+512+y0,p0,13,1,40);
      }
      if(f==1) {
         ++y0; mover(pmb+512+y0,p0,13,1,40);
      }
   }
}

// Same as SOUND BASIC
void sound(int c, int p, int d, int v) {
   poke(53760U+(c<<1),p); poke(53761U,(d<<4)+v);
}


// Draw a hole in the (hx,hy) screen position
void hole(int hx, int hy)
{
   unsigned char i, s;
   unsigned char noffset[34] =
      { 1,0,2,0,5,0,
        3,1,5,1,
        0,2,1,2,2,2,3,2,4,2,
        2,3,3,3,4,3,
        1,4,3,4,5,4,
        3,5 };
   unsigned char nsound[10] = {180,4,230,8,200,10,160,7,0,0};

   for(i=0;i<34;i+=2) {
      s=(i>>3);
      sound(0,nsound[s],12,nsound[s+1]);
      plot_4colmode_nc(bmp_pres, hx+noffset[i], hy+noffset[i+1], 4);
   }
}


// Update the status when button is pressed
void button()
{
   int i, ii, tpp, sw;

   if(peek(0x284)==0) {  // 53264 Read register STRIG0
      sound(3,65,12,10);sound(2,60,12,15);
      --nbalas; // print boorado de balas
      for(i=0;i<nlevel;++i) {

      	 tpp=m[i][3];  // Get the enemy type

      	 if(m[i][1]!=0) {
      	    if(tpp==1 && m[i][0]<px0-40 && m[i][0]+tipo[tpp-1][1]*4>px0-40 && y0>118-m[i][1]) {
      	       //mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40,tipo[tpp-1][4],tipo[tpp-1][1],tipo[tpp-1][2],40);
      	       for(ii=0;ii<tipo[tpp-1][2]-1;++i) {
      	       	  //mover(bmp_pres->dat+(m[i][0]>>2)+(tipo[tpp-1][0]+ii)*40,tipo[tpp-1][4],tipo[tpp-1][1],tipo[tpp-1][2]-ii,40);
      	       	  sound(2,22,12,8); sound(3,14,12,4); sound(2,37,12,7); sound(3,18,12,3); sound(3,0,0,0);
      	       }
      	       sound(2,0,0,0);
      	       m[i][1]=0; m[i][4]=rand()%7+21; ++ndied;
      	    }

            if(tpp==2 && m[i][0]<px0-40 && m[i][0]+tipo[tpp-1][1]*4>px0-40 && y0>77-m[i][1] && y0<58) {
      	       //mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40,tipo[tpp-1][4],tipo[tpp-1][1],tipo[tpp-1][2],40);
               for(ii=1;ii<=60;++ii) {
               	  sound(2,22,12,8);sound(3,14,12,4);sound(2,37,12,7);sound(3,18,12,3);sound(3,0,0,0);
               }
               sound(2,0,0,0);
               //mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40,fondo,tipo[tpp-1][1],tipo[tpp-1][2],40);
               m[i][1]=0; m[i][4]=rand()%7+21; ++ndied;
            }

            if(tpp==4 && m[i][0]<px0-40 && m[i][0]+tipo[tpp-1][1]*4>px0-40 && y0>43-m[i][1] && y0<22) {
      	       //mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40,tipo[tpp-1][4],tipo[tpp-1][1],tipo[tpp-1][2],40);
               sound(0,0,0,0);
               for(ii=0;ii<tipo[tpp-1][2]-1;++ii) {
      	          //mover(bmp_pres->dat+(m[i][0]>>2)+(tipo[tpp-1][0]+ii)*40,tipo[tpp-1][4],tipo[tpp-1][1],tipo[tpp-1][2]-ii,40);
               	  sound(2,200,12,8);sound(3,180,12,4);sound(2,145,12,7);sound(3,90,12,3);sound(3,0,0,0);
               }
               sound(2,0,0,0);
               m[i][1]=0; m[i][4]=rand()%7+21; ++ndied;
            }

            if(tpp==3 && y0>43-m[i][1] && y0<28) {
               sw=0; sw=(px0>53 && px0<68 && m[i][0]==tipo[2][5]);
               sw += (px0>74 && px0<89 && m[i][0]==tipo[2][6]) + (px0>92 && px0<107 && m[i][0]==tipo[2][7]);
               if(sw!=0) {
               	  // Print Soldier window dying
               	  mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40, tipo[tpp-1][4], tipo[tpp-1][1], tipo[tpp-1][2], 40);
               	  for(ii=0;ii<60;++ii) {
               	     sound(2,22,12,8); sound(3,14,12,4); sound(2,37,12,7); sound(3,18,12,3); sound(3,0,0,0);
               	  }
               	  sound(2,0,0,0);
               	  // Print window in black
               	  copia_char_bloque(bmp_pres->dat+(m[i][0]>>2)+tipo[tpp-1][0]*40, 0x00,  tipo[tpp-1][1], tipo[tpp-1][2], 40);
               	  m[i][1]=0; m[i][4]=rand()%7+21; ++ndied;
               }
            }
         }
      }
      sound(3,0,0,0); sound(2,0,0,0);
      // print ndied
   }
}

// Load empty gun
void carga()
{
   unsigned char s;
   s=peek(0x278); // read joystick
   poke(704,rand());
   if(((s==7 && ss==11) || (s==11 && ss==7)) && ncartus>0) {
      ++nbal; ss=s; sound(0,60,12,15);
      // Imprime BALAS
      if(nbal=20) {
      	 nbalas=nbal; nbal=0;
      	 // Borra 1 cartus
      	 --ncartus;
      	 poke(704,10);
      }
   }
}


void main()
{
   unsigned char *b1, *b2;

   tipo[0][3] = a1; tipo[0][4] = a2;
   tipo[1][3] = a3; tipo[1][4] = a4;
   tipo[2][3] = a5; tipo[2][4] = a6;
   tipo[3][3] = a7; tipo[3][4] = a8;

   bmp_pres = create_bitmap(0x0E, 160, 192);
   dl_setup[3].bmp = bmp_pres;
   b1 = create_display_list(dl_setup);
   activate_display_list(b1);

   poke(708,6); poke(709,10);

   // Create init screen
   //mover(bmp_pres->dat, rotulo, 40, 53, 40);
   textout_4colmode_nc(bmp_pres, sysfont, "MCA SOFTWARE 90", 17, 67, 2);
   copia_char_bloque(bmp_pres->dat+80*40,0x55,24,60,40);
   copia_char_bloque(bmp_pres->dat+80*40+24,0xFF,16,60,40);
   textout_4colmode_nc(bmp_pres, sysfont, "Programed by :", 24, 150, 1);
   textout_4colmode_nc(bmp_pres, sysfont, "MARIO CAILLAHUZ A.", 8, 160, 2);

   for(i=60;i>0;--i) mover(bmp_pres->dat+3192+i*40,a1,8,61-i,40); // Soldier appears
   hole(20,95);
   hole(70,120);
   hole(130,110);
   mover(bmp_pres->dat+3232, a2, 8, 60, 40);
   hole(150,99);
   for(i=1;i<61;++i) {  // Soldier die
      mover(bmp_pres->dat+3192+i*40,a2,8,61-i,40);
      sound(2,22,12,8);sound(3,14,12,4);sound(2,37,12,7);sound(3,18,12,3);sound(3,0,0,0);
   }

   while(peek(53279U)!=6) {  // When START key is pressed....
      textout_4colmode_nc(bmp_pres, sysfont, "Press <START>", 28, 170, 1);
      textout_4colmode_nc(bmp_pres, sysfont, "Press <START>", 28, 170, 2);
      textout_4colmode_nc(bmp_pres, sysfont, "Press <START>", 28, 170, 0);
   };

   // Change display list Gr.15 (with bottom text window)

   dl_setup2[3].bmp = bmp_pres;
   b2 = create_display_list(dl_setup2);
   activate_display_list(b2);
   clear_bitmap(bmp_pres);
   destroy_display_list(b1);

   // INIT PMs
   poke(559,46);
   pm = peek(106)-4; pmb=256*pm;
   poke(704,10); poke(705,20);
   poke(623,1); poke(53277U,3); poke(54279U,pm); poke(53256U,0); poke(53257U,3);
   y0=61;
   px0=116; py0=pmb+512+y0;
   px1=92;  py1=pmb+640+55;
   copia_char(pmb,1024,0); // Limpia zona de sprites
   mover(py0, p0, 13, 1, 40); poke(53248U, px0);
   mover(py1, p1, 10, 1, 40); poke(53249U, px1);
   poke(708,132); poke(709,70); poke(710,200); poke(712,0);

   // Draw green floor
   copia_char(bmp_pres->dat+90*40,2800,255);

   // Draw sky
   copia_char(bmp_pres->dat,3600,0x55);

   // Draw house
   for(i=0;i<=44;++i) {
      copia_char(bmp_pres->dat+i*80,20,0xAA);
   }
   for(i=0;i<=2;++i) {
      copia_char_bloque(bmp_pres->dat+10*40+2+i*5,0x00,4,30,40);
   }

   // Draw valla
   copia_char_bloque(bmp_pres->dat+18+30*40,0xBB,22,64,40);

   // Write status texts
   mover(bmp_pres->dat+40*160+3, rotulov, 9, 4, 40);

   // Init vars
   nmax_level=9; nlevel=1; nbalas=20; ncartus=10; nenergy=25;


   // Main process
   ss=11; ndied=0; salir=0; nbal=0;
   while(salir==0) {
      for(i=0;i<nlevel;++i) {

      	 tp=m[i][3];    // Get the player shape
      	 sound(2,0,0,0);

      	 if(m[i][4]<rand()%29 + 1) {
      	    if( m[i][1] != tipo[tp-1][2]) {
      	       if( m[i][1] == 0) {
      	          m[i][4]=0;
      	          if(tp==1 || tp==2 || tp==4) {
      	             m[i][0]=tipo[tp-1][6]+rand()%(tipo[tp-1][5]-tipo[tp-1][6]+1);
      	             m[i][2]=m[i][0];
      	          }
      	          if(tp==3) {
      	             m[i][0]=tipo[tp-1][rand()%3+5];
      	             m[i][2]=m[i][0];
      	          }
      	          if(tp==4) {
      	             sound(0,220,12,12);
      	          }
      	       }
      	       m[i][1]=m[i][1]+tipo[tp-1][8];
      	       // Print enemy at window appearing
      	       mover(bmp_pres->dat+(m[i][0]>>2)+tipo[tp-1][0]*40 + (tipo[tp-1][2]-m[i][1])*40,
      	             tipo[tp-1][3], tipo[tp-1][1], m[i][1], 40);
      	    }
      	    else
      	    {
      	       aux=bmp_pres->dat+m[i][0]/4+tipo[tp-1][0]*40;
      	       if(tp==1 || tp==4) {
      	       	  if(m[i][2]==m[i][0]) {
      	       	     m[i][2]=tipo[tp-1][6]+rand()%(tipo[tp-1][5]-tipo[tp-1][6]+1);
      	       	  }
      	          sg = (m[i][2]>m[i][0],1,(m[i][2]==m[i][0],0,-1));
      	          m[i][0]=m[i][0]+sg;
      	       }
      	       if(tp==2 || tp==4) {
      	          mover(aux,tipo[tp-1][3],tipo[tp-1][1],tipo[tp-1][2],40);
      	       }
      	       if(tp==2) {
   	          if(m[i][0]<2) {
      	             m[i][1]= 0;
      	             //mover(bmp_pres->dat+tipo[1][0]*40,fondo,tipo[1][1],tipo[1][2],40);
      	          }
      	          m[i][0]=m[i][0]-1;
      	       }
      	       if(tp==1 && sg==-1) {
      	           mover(aux,bmp_pres->dat+m[i][1]/4+tipo[tp-1][1]*40,40,60,40);
      	       }
      	       if(tp==1 && sg==1) {
      	           mover(aux,bmp_pres->dat+m[i][1]/4+tipo[tp-1][1]*40,40,60,40);
      	       }
      	       if(rand()%(28+nlevel)>26) {
      	       	  sound(2,100,12,10);
      	          --nenergy;
      	          if(nenergy<=25) {
      	             // retira una energia en pantalla
      	          }
      	       }
      	    }
      	 }

      	 // Check joystick, button press and reload requirement
      	 if(nbalas>0) {
      	    joystick();
      	    button();
      	 }
         else
      	 {
      	    carga();
      	 }

      	 // Exit
      	 if(nenergy=0) {
      	    salir=1;
      	 }

      	 // Update level state and last game objective
      	 if(ndied>nivel[nlevel]) {
      	    ++nlevel;
      	    nenergy += 5;
      	    // Print energy
      	    if(nlevel==10) {
      	       //acabo
      	    }
      	 }
      }
   }




      plot_4colmode_nc(bmp_pres, 0,10, 0);

   //    rectfill_4colmode_nc(bmp1, rand()%100, rand()%100, x, y, c);
   // textout_4colmode_nc(bmp1, sysfont, "Hello!", rand()%100, rand()%100, c);

   // plot_4colmode_nc(bmp_pres,  0,10, 0);
   // plot_4colmode_nc(bmp_pres,  1,10, 0);


   destroy_bitmap(bmp_pres);
   destroy_display_list(b2);

   printf("Final -- Pulsa START para salir");
   while(peekw(53279U)!=6) {  // Wait START
   }
}

