#define poke(addr,val)     (*(unsigned char*) (addr) = (unsigned char)(val))
#define pokew(addr,val)    (*(unsigned*) (addr) = (unsigned)(val))
#define peek(addr)         (*(unsigned char*)(addr))
#define peekw(addr)        (*(unsigned*)(addr))

#define FONT        unsigned char
#define sysfont     ((FONT *) 0xE000)        // main system font
#define intfont     ((FONT *) 0xCC00)        // international font (XL/XE)

/* Bitmap structure
 *
 * To keep track of bitmaps in memory for drawing, etc...
 */
typedef struct BITMAP {
	   char *dat;               // pointer to actual data
  unsigned char mode;               // graphics mode of bitmap (antic)
  unsigned char bpl;                // bytes per line (max = 255)
  //unsigned char clip;               // clipping?
   unsigned int w, h;               // width and height of bitmap
} BITMAP;

/* Display List setup structure
 *
 *  mode, lines, bitmap, hscroll, vscroll, dli, dli_address
 *
 * Last entry should be a FF for the mode line.
 */
typedef struct DL_SETUP_T {
  unsigned char mode;           // Antic mode
  unsigned char lines;          // number of antic mode lines
  BITMAP        *bmp;           // Bitmap pointer
  unsigned char hscroll;        // Horizontal scroll enable?
  unsigned char vscroll;        // Vertical scroll enable?
  unsigned char dli_flag;       // DLI flag
  void          *dli_address;   // DLI address
} DL_SETUP_T;


/* Display list structure
 */
typedef struct DLIST {
  DL_SETUP_T *setup;
  char *dat;
} DLIST;

extern void __fastcall__ plot_4colmode_nc(BITMAP *bmp, unsigned int x, unsigned int y, unsigned char creg);
extern void __fastcall__ textout_4colmode_nc(BITMAP *bmp, FONT *font, const char *s, unsigned int x, unsigned int y, char creg);

extern BITMAP* __fastcall__ create_bitmap(unsigned char mode, unsigned int w, unsigned int h);
extern void __fastcall__ clear_bitmap(BITMAP *bmp);
extern BITMAP* __fastcall__ destroy_bitmap(BITMAP *bmp);

extern char* __fastcall__ create_display_list(DL_SETUP_T *list);
extern void __fastcall__ destroy_display_list(char *b);
extern void __fastcall__ activate_display_list(char *dl);

extern void mover(int n1, unsigned char *n2, int n3, int n4, int n5);
extern void copia_char(unsigned char *n1, int n2, unsigned char n3);
extern void copia_char_bloque(int n1, int n2, int n3, int n4, int n5);
